// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef COMPLETE_PLATFORM_HH
#define COMPLETE_PLATFORM_HH

#include <stdint.h>
#include "accelerometer_apb_wrapper.hpp"
#include "actuator.hpp"
#include "amba_apb_bus.hpp"
#include "lfsr_apb_wrapper.hpp"
#include "m6502.hpp"
#include "memory_inst.hpp"
#include "multiplier_apb_wrapper.hpp"
#include "network_interface_apb_wrapper.hpp"
#include "sensor.hpp"
#include "watchdog_apb_wrapper.hpp"

class complete_platform
{

public:

    bool sensor_low_old;
    bool sensor_high_old;
    bool rst_old;
    bool clk_old;
    struct complete_platform_iostruct{
        bool clk;
        bool rst;
        bool sensor_high;
        bool sensor_low;
        bool actuator_open;
        bool actuator_close;
        uint16_t actuator_threshold;

        complete_platform_iostruct():
            clk(false),
            rst(false),
            sensor_high(false),
            sensor_low(false),
            actuator_open(false),
            actuator_close(false),
            actuator_threshold(uint16_t(0U))
        {}

        complete_platform_iostruct( const bool clk_5, const bool rst_1, const bool
             sensor_high_1, const bool sensor_low_1, const bool actuator_open_1,
             const bool actuator_close_1, const uint16_t actuator_threshold_1 ):
            clk(clk_5),
            rst(rst_1),
            sensor_high(sensor_high_1),
            sensor_low(sensor_low_1),
            actuator_open(actuator_open_1),
            actuator_close(actuator_close_1),
            actuator_threshold(actuator_threshold_1)
        {}

        ~complete_platform_iostruct()
        {}

        bool operator == (const complete_platform_iostruct & other) const
        {
            if (clk != other.clk) return false;
            if (rst != other.rst) return false;
            if (sensor_high != other.sensor_high) return false;
            if (sensor_low != other.sensor_low) return false;
            if (actuator_open != other.actuator_open) return false;
            if (actuator_close != other.actuator_close) return false;
            if (actuator_threshold != other.actuator_threshold) return false;
            return true;
        }
    };
    complete_platform_iostruct hif_a2t_data;
    bool apb_master_pclk;
    bool apb_master_presetn;
    uint32_t apb_master_paddr;
    bool apb_master_psel1;
    bool apb_master_psel2;
    bool apb_master_psel3;
    bool apb_master_psel4;
    bool apb_master_psel5;
    bool apb_master_psel6;
    bool apb_master_psel7;
    bool apb_master_psel8;
    bool apb_master_penable;
    bool apb_master_pwrite;
    uint32_t apb_master_pwdata;
    bool apb_master_pready;
    uint32_t apb_master_prdata;
    bool apb_1_pclk;
    bool apb_1_presetn;
    uint32_t apb_1_paddr;
    bool apb_1_psel;
    bool apb_1_penable;
    bool apb_1_pwrite;
    uint32_t apb_1_pwdata;
    bool apb_1_pready;
    uint32_t apb_1_prdata;
    bool apb_2_pclk;
    bool apb_2_presetn;
    uint32_t apb_2_paddr;
    bool apb_2_psel;
    bool apb_2_penable;
    bool apb_2_pwrite;
    uint32_t apb_2_pwdata;
    bool apb_2_pready;
    uint32_t apb_2_prdata;
    bool apb_3_pclk;
    bool apb_3_presetn;
    uint32_t apb_3_paddr;
    bool apb_3_psel;
    bool apb_3_penable;
    bool apb_3_pwrite;
    uint32_t apb_3_pwdata;
    bool apb_3_pready;
    uint32_t apb_3_prdata;
    bool apb_4_pclk;
    bool apb_4_presetn;
    uint32_t apb_4_paddr;
    bool apb_4_psel;
    bool apb_4_penable;
    bool apb_4_pwrite;
    uint32_t apb_4_pwdata;
    bool apb_4_pready;
    uint32_t apb_4_prdata;
    bool apb_5_pclk;
    bool apb_5_presetn;
    uint32_t apb_5_paddr;
    bool apb_5_psel;
    bool apb_5_penable;
    bool apb_5_pwrite;
    uint32_t apb_5_pwdata;
    bool apb_5_pready;
    uint32_t apb_5_prdata;
    bool apb_6_pclk;
    bool apb_6_presetn;
    uint32_t apb_6_paddr;
    bool apb_6_psel;
    bool apb_6_penable;
    bool apb_6_pwrite;
    uint32_t apb_6_pwdata;
    bool apb_6_pready;
    uint32_t apb_6_prdata;
    bool apb_7_pclk;
    bool apb_7_presetn;
    uint32_t apb_7_paddr;
    bool apb_7_psel;
    bool apb_7_penable;
    bool apb_7_pwrite;
    uint32_t apb_7_pwdata;
    bool apb_7_pready;
    uint32_t apb_7_prdata;
    bool apb_8_pclk;
    bool apb_8_presetn;
    uint32_t apb_8_paddr;
    bool apb_8_psel;
    bool apb_8_penable;
    bool apb_8_pwrite;
    uint32_t apb_8_pwdata;
    bool apb_8_pready;
    uint32_t apb_8_prdata;
    uint16_t addr;
    uint8_t datai;
    uint8_t datao;
    bool oeb;
    bool irq_n;
    bool nmi_n;
    bool res_n;
    bool rdy;
    bool sob_n;
    bool sync;
    bool vpab;
    bool we_n;
    complete_platform();


    ~complete_platform();


    m6502 m6502_0;
    memory_inst memory_0;
    amba_apb_bus amba_apb_bus_0;
    multiplier_apb_wrapper multiplier_0;
    accelerometer_apb_wrapper accelerometer_0;
    network_interface_apb_wrapper network_interface_0;
    lfsr_apb_wrapper lfsr_0;
    sensor sensor_0;
    actuator actuator_0;
    watchdog_apb_wrapper watchdog_0;
    bool apb_master_pclk_new;
    bool apb_master_presetn_new;
    uint32_t apb_master_paddr_new;
    bool apb_master_psel1_new;
    bool apb_master_psel2_new;
    bool apb_master_psel3_new;
    bool apb_master_psel4_new;
    bool apb_master_psel5_new;
    bool apb_master_psel6_new;
    bool apb_master_psel7_new;
    bool apb_master_psel8_new;
    bool apb_master_penable_new;
    bool apb_master_pwrite_new;
    uint32_t apb_master_pwdata_new;
    bool apb_master_pready_new;
    uint32_t apb_master_prdata_new;
    bool apb_1_pclk_new;
    bool apb_1_presetn_new;
    uint32_t apb_1_paddr_new;
    bool apb_1_psel_new;
    bool apb_1_penable_new;
    bool apb_1_pwrite_new;
    uint32_t apb_1_pwdata_new;
    bool apb_1_pready_new;
    uint32_t apb_1_prdata_new;
    bool apb_2_pclk_new;
    bool apb_2_presetn_new;
    uint32_t apb_2_paddr_new;
    bool apb_2_psel_new;
    bool apb_2_penable_new;
    bool apb_2_pwrite_new;
    uint32_t apb_2_pwdata_new;
    bool apb_2_pready_new;
    uint32_t apb_2_prdata_new;
    bool apb_3_pclk_new;
    bool apb_3_presetn_new;
    uint32_t apb_3_paddr_new;
    bool apb_3_psel_new;
    bool apb_3_penable_new;
    bool apb_3_pwrite_new;
    uint32_t apb_3_pwdata_new;
    bool apb_3_pready_new;
    uint32_t apb_3_prdata_new;
    bool apb_4_pclk_new;
    bool apb_4_presetn_new;
    uint32_t apb_4_paddr_new;
    bool apb_4_psel_new;
    bool apb_4_penable_new;
    bool apb_4_pwrite_new;
    uint32_t apb_4_pwdata_new;
    bool apb_4_pready_new;
    uint32_t apb_4_prdata_new;
    bool apb_5_pclk_new;
    bool apb_5_presetn_new;
    uint32_t apb_5_paddr_new;
    bool apb_5_psel_new;
    bool apb_5_penable_new;
    bool apb_5_pwrite_new;
    uint32_t apb_5_pwdata_new;
    bool apb_5_pready_new;
    uint32_t apb_5_prdata_new;
    bool apb_6_pclk_new;
    bool apb_6_presetn_new;
    uint32_t apb_6_paddr_new;
    bool apb_6_psel_new;
    bool apb_6_penable_new;
    bool apb_6_pwrite_new;
    uint32_t apb_6_pwdata_new;
    bool apb_6_pready_new;
    uint32_t apb_6_prdata_new;
    bool apb_7_pclk_new;
    bool apb_7_presetn_new;
    uint32_t apb_7_paddr_new;
    bool apb_7_psel_new;
    bool apb_7_penable_new;
    bool apb_7_pwrite_new;
    uint32_t apb_7_pwdata_new;
    bool apb_7_pready_new;
    uint32_t apb_7_prdata_new;
    bool apb_8_pclk_new;
    bool apb_8_presetn_new;
    uint32_t apb_8_paddr_new;
    bool apb_8_psel_new;
    bool apb_8_penable_new;
    bool apb_8_pwrite_new;
    uint32_t apb_8_pwdata_new;
    bool apb_8_pready_new;
    uint32_t apb_8_prdata_new;
    uint16_t addr_new;
    uint8_t datai_new;
    uint8_t datao_new;
    bool oeb_new;
    bool irq_n_new;
    bool nmi_n_new;
    bool res_n_new;
    bool rdy_new;
    bool sob_n_new;
    bool sync_new;
    bool vpab_new;
    bool we_n_new;
    bool process_in_queue;

    bool perform_bindings();

    bool _bindings_completed;

    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void synch_elaboration();


    void simulate( complete_platform_iostruct * io_exchange, int32_t & cycles_number
         );


    void start_of_simulation();


    void initialize();


    void finalize();


private:

    complete_platform( const complete_platform & );
    const complete_platform& operator= ( const complete_platform & );


};


#endif

